/** @file dibsection.h

	Skelton for retropc emulator

	@author Sasaji
	@date   2013.10.30 -

	@brief [ dibsection ]
*/

#ifndef _DIBSECTION_H_
#define _DIBSECTION_H_

#include <windows.h>
#include "common.h"

/**
	@brief manage DIB section
*/
class DibSection
{
protected:
	HDC       hMainDib;
	HANDLE    hMainBuf;
	HBITMAP   hMainBmp;
	scrntype *pMainBuf;

	bool      enable;

public:
	DibSection();
	DibSection(HDC hdc, long width, long height);
	~DibSection();

	bool CreateDib(HDC hdc, long width, long height, HANDLE *hBuf, HBITMAP *hBmp, scrntype **pBuf, HDC *hdcDib);
	bool CreateDib(HDC hdc, long width, long height);
	void ReleaseDib(HANDLE *hBuf, HBITMAP *hBmp, HDC *hdcDib);
	void ReleaseDib();

	HDC GetDC() { return hMainDib; }
	HANDLE GetHHeader() { return hMainBuf; }
	HBITMAP GetBitmap() { return hMainBmp; }
	scrntype *GetBuffer();
	DWORD GetBufferSize();
	LPBITMAPINFOHEADER GetHeader();
	DWORD GetHeaderSize();

	bool IsEnable() { return enable; }
};

#endif
