/** @file win_folderbox.cpp

	HITACHI MB-S1 Emulator 'EmuB-S1'
	Skelton for retropc emulator

	@author Sasaji
	@date   2015.03.21 -

	@brief [ folder box ]
*/

#include "win_folderbox.h"

namespace GUI_WIN
{

FolderBox::FolderBox(HWND parent_window)
{
	hWnd = parent_window;
}

FolderBox::~FolderBox()
{
}

int CALLBACK FolderBox::Proc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	if(uMsg == BFFM_INITIALIZED) {
		SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpData);
	}
	return 0;
}

bool FolderBox::Show(const _TCHAR *title, _TCHAR *path)
{
	BROWSEINFO  binfo;
	PCIDLIST_ABSOLUTE idlist;

	memset(&binfo, 0, sizeof(BROWSEINFO));
	binfo.hwndOwner=hWnd;
	binfo.pidlRoot=NULL;
	binfo.pszDisplayName=path;
	binfo.lpszTitle=title;
	binfo.ulFlags=BIF_RETURNONLYFSDIRS;
	binfo.lpfn=&Proc;
	binfo.lParam=(LPARAM)path;
	binfo.iImage=(int)NULL;

	idlist=SHBrowseForFolder(&binfo);
	if (idlist != NULL) {
		SHGetPathFromIDList(idlist, path);
		CoTaskMemFree((LPVOID)idlist);
		return true;
	}
	return false;
}

}; /* namespace GUI_WIN */
